SystemOrganization addCategory: #BICHOS!

Object subclass: #EstadoCansada
	instanceVariableNames: 'ubicacionesPorEstado alimentoPorEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:32'!
alimentoPorEstado

	^ alimentoPorEstado min: 0.! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:31'!
alimentoPorEstado: unaCantidad
	alimentoPorEstado := unaCantidad.
! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:32'!
descansa: hormigaAfectada
	hormigaAfectada normalizada.! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:31'!
ubicacionesPorEstado

	^ ubicacionesPorEstado.! !

Object subclass: #EstadoExaltada
	instanceVariableNames: 'ubicacionesPorEstado alimentoPorEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:31'!
alimentoPorEstado

	^ (alimentoPorEstado min: 10)*2.! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:30'!
alimentoPorEstado: unaCantidad
	alimentoPorEstado := unaCantidad.
! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:30'!
descansa: hormigaAfectada! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:30'!
ubicacionesPorEstado

	^ ubicacionesPorEstado.! !

Object subclass: #EstadoNormal
	instanceVariableNames: 'ubicacionesPorEstado alimentoPorEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:26'!
alimentoPorEstado

	^ alimentoPorEstado min: 10.! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:26'!
alimentoPorEstado: unaCantidad
	alimentoPorEstado := unaCantidad.
! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:28'!
descansa: hormigaAfectada
	hormigaAfectada exaltada.! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:37'!
ubicacionesPorEstado

	^ ubicacionesPorEstado.! !

Object subclass: #Hormiga
	instanceVariableNames: 'hormiguero comidaQueLleva ubicacion estado ubicaciones moveteA unaUbicacion distanciaRecorrida ubicacionesPorLasQuePaso distanciasTotales cantidadDeUbicacionesPorLasQuePaso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:56'!
alLimite
	
	^ self comidaQueLleva >= 9.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:08'!
cansada
	
	self estado: EstadoCansada new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:20'!
cantidadDeUbicacionesPorLasQuePaso

	^ self ubicacionesPorLasQuePaso size.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:52'!
comidaQueFaltaParaLlegarAlLimite

	^ 10 - self comidaQueLleva.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:01'!
comidaQueLleva

	^ comidaQueLleva.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:54'!
comidaQueLleva: anObject

	comidaQueLleva:= anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:09'!
descansa

	estado descansa: self.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:23'!
distanciaPromedio

	^ self distanciaRecorrida / self cantidadDeUbicacionesPorLasQuePaso.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:17'!
distanciaRecorrida

	^ distanciaRecorrida! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:17'!
distanciaRecorrida: anObject

	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:49'!
distanciaRecorridaEnUltimosPuntos: unaCantidad
	
	^ (self distanciasTotales last: unaCantidad) sum.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:21'!
distanciaRecorridaEstadoDeterminado
	
	
	^ (self distanciaRecorridaEnUltimosPuntos:  estado cantidadDeUbicacionesPorLasQuePaso )! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:46'!
distanciasTotales
	^distanciasTotales.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:31'!
estado
	^ estado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:31'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:59'!
exaltada
	
	self estado: EstadoExaltada new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:26'!
initialize
	self comidaQueLleva: 0.
	distanciaRecorrida := 0.
	estado := EstadoNormal new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:57'!
limiteDisponible

	^ 10 - comidaQueLleva.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:35'!
llevarAlimentoA: unHormiguero

	estado llevarAlimentoA: unHormiguero con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:08'!
moveteA: unaUbicacion
	
	moveteA := unaUbicacion! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:10'!
normalizada
	self estado: EstadoNormal new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:10'!
ubicacion
	
	^ ubicacion.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:10'!
ubicacion: unEspacio

	ubicacion:= unEspacio.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:25'!
ubicacionesPorLasQuePaso

	^ ubicacionesPorLasQuePaso.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:17'!
ultimasUbicacionesPorLasQuePaso: unaCantidad

	^self ubicacionesPorLasQuePaso last: unaCantidad.! !

Object subclass: #Hormiguero
	instanceVariableNames: 'depositoDeComida hormigasTotales ubicacion hormigas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:47'!
agregarComida

	^ self hormigasEnElHormiguero sum: [:unaHormiga | unaHormiga comidaQueLleva].
	
! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:01'!
agregarHormiga: unaHormiga

	self hormigasTotales add: unaHormiga.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:14'!
cantidadHormigasTotales

	^hormigasTotales size.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:23'!
comidaEnTotal

	^depositoDeComida + self comidaRecolectada.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:30'!
comidaRecolectada

	^ hormigasTotales sum: [: hormiga | hormiga comidaQueLleva].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:11'!
depositoDeComida

	^depositoDeComida.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:22'!
depositoDeComida: anObject

	depositoDeComida := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:07'!
hormigasEnElHormiguero

	^  self hormigasTotales select: [:unaHormiga | unaHormiga ubicacion = self ubicacion].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 18:29'!
hormigasTotales
	
	^ hormigasTotales.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:03'!
hormigasTotales: anObject 

	hormigasTotales:= anObject 	! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:15'!
initialize

	hormigasTotales:= Bag new.
	depositoDeComida:=0.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:44'!
recibirYAgregarLaComida

	^depositoDeComida  := (self depositoDeComida + self agregarComida).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:08'!
ubicacion
	
	^ ubicacion.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:08'!
ubicacion: unaUbicacion

	ubicacion := unaUbicacion.! !
